c....	30.01.2003 M.Roellig
c....   Changes due to compilation on Linux/g77 rather than alpha
c....   standard g77 allows for 100 files to be opened
c....   -> unit numbers greater 100 are changed 
c....   Changes: rewind/open/write(115  -->  rewind/open/write(45
c....   Changes: rewind/open/write(114  -->  rewind/open/write(44
c....   Changes: rewind/open/write(113  -->  rewind/open/write(43
c....   Changes: rewind/open/write(112  -->  rewind/open/write(42
c....   Changes: rewind/open/write(111  -->  rewind/open/write(41

C       Exp2 Namen abaendern !!!! fuer SX3-Version 
C       A_V = 1.086  * TAU_UV / 1.9 
CB  NEW: 20.10.1992      A_V = TAU_UV / 4.0

      BLOCK DATA
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
 
C      Three-level-atom (data see Tielens & Hollenbach) Ap.J. 291
C      ADAT(1..3) A-values
C      ADAT(4..9) coefficients for collisional rates (atomic hydrogen)
C      ADAT(10...12)  nu/c (und nicht delta nu/c!!) =lambda**(-1)   
C      ADAT(13..15) statistical weights   
C CIORTHO, CIPARA, OIORTHO, OIPARA: coefficients for collisional
C rates with ortho/para H2, see Spaans et al.,1994,  ApJ 437, 270,
C Schroeder et al. 1991, J. Phys. B, 24, 2487 and Jaquet et al. 1992, J. Phys. B,
C 25, 285
C APARA(1...6): T < 150K
C APARA(7...12): 150K < T < 1000K
C APARA(13...18): T > 1000K
C analog for AORTHO
      COMMON /CI/ CIDAT(16),CIDEN(3),CICOL(3),CITAU(3),CIPARA(18),
     >     CIORTHO(18)
      COMMON /OXY/ OXYDAT(16),OXYDEN(3),OXYCOL(3),OXYTAU(3),
     >     OXYPARA(18),OXYORTHO(18)
      COMMON /FEP/ FEDAT(16),FEDEN(3),FECOL(3),FETAU(3)
      DATA CIDAT /7.93D-08,2.0D-14,2.68D-07,1.3D-10,2.0D-10,7.8D-11,
     >             0.045D0,0.084D0,0.035D0,16.39D0,43.48D0,27.03D0,
     >             1.D0,3.D0,5.D0,3.0D-04/
      DATA CIPARA  /1.60D-10,1.18D-10,2.09D-10,-0.19,-0.07,-0.04,
     1              3.50D-11,4.22D-11,6.71D-11,0.13,0.13,0.20,
     2              8.10D-11,1.03D-10,2.61D-10,0.00,0.00,0.00/
      DATA CIORTHO /1.05d-10,3.1d-11,4.5d-11,-0.08,0.18,0.27,
     1              3.72d-11,3.1d-11,4.5d-11,0.12,0.18,0.27,
     2              8.50d-11,3.1d-11,4.5d-11,0.00,0.18,0.27/

      DATA OXYDAT /8.95D-05,1.0D-10,1.70D-05,4.2D-12,1.1D-12,1.5D-10,
     1             0.67D0,0.80D0,0.44D0,158.228D0,227.273D0,68.6813D0,
     2             5.D0,3.D0,1.D0,5.0D-04/
      DATA OXYPARA /3.40d-11,5.77d-11,3.34d-15,0.32,0.30,1.36,
     1              3.40d-11,5.77d-11,3.34d-15,0.32,0.30,1.36,
     2              3.40d-11,5.77d-11,3.34d-15,0.32,0.30,1.36/
      DATA OXYORTHO /2.45D-11,4.09D-11,2.74D-14,0.38,0.37,1.06,
     1               2.45D-11,4.09D-11,2.74D-14,0.38,0.37,1.06,
     2               2.45D-11,4.09D-11,2.74D-14,0.38,0.37,1.06/

      DATA FEDAT /2.13D-03,1.5D-09,1.57D-03,9.5D-10,5.7D-10,4.7D-10,
     1             0.D0,0.D0,0.D0,385.04D0,667.90D0,
     2             282.87D0,10.D0,8.D0,6.D0,2.5D-07/

C      H2-dissociation and branching rations
      COMMON/EDIS/ EDISRB,EDISRC,EBD(0:23),ECD(0:9)
      DATA EBD /4.840D+02,1.533D+03,6.453D+02,5.646D+02,1.049D+03,
     1          5.646D+02,1.371D+03,8.066D+02,1.291D+03,1.775D+03,
     2          2.581D+03,3.388D+03,3.307D+03,4.033D+03,4.517D+03,
     3          4.920D+03,5.566D+03,5.646D+03,6.130D+03,6.291D+03,
     4          6.695D+03,7.179D+03,7.421D+03,7.663D+03/
      DATA ECD /7.905D+03,6.050D+03,1.694D+03,1.210D+03,7.259D+02,
     1          1.533D+03,6.453D+02,1.694D+03,5.646D+02,1.452D+03/
 
C      H2-vibrational-levels (data see Sternberg&Dalgarno
C      AP. J. 338)   
  
  
      COMMON /ENERGY/ EX(15),EB(24),EC(10)                         
      COMMON /BANDB/ FBANDB(0:14,0:23),AVBTOT(0:23),ABCONT(0:23),      
     >                DFVB(0:23)                                        
      COMMON /BANDC/ FBANDC(0:14,0:9),DFVC(0:9) 
      DATA AVBTOT /1.868D+09,1.741D+09,1.632D+09,1.536D+09,1.450D+09,
     1              1.372D+09,1.301D+09,1.236D+09,1.177D+09,1.122D+09,
     2              1.072D+09,1.025D+09,9.804D+08,9.391D+08,9.003D+08,
     3              8.640D+08,8.301D+08,7.990D+08,7.702D+08,7.439D+08,
     4              7.199D+08,6.981D+08,6.783D+08,6.598D+08/
      DATA ABCONT /5.632D+00,1.145D+02,2.197D+04,1.774D+05,2.153D+06,
     1              2.341D+07,4.019D+07,2.609D+08,3.424D+08,4.659D+08,
     2              4.398D+08,4.176D+08,5.127D+08,4.798D+08,4.883D+08,
     3              4.824D+08,4.601D+08,4.803D+08,4.681D+08,4.716D+08,
     4              4.589D+08,4.486D+08,4.417D+08,4.346D+08/
      DATA DFVB   /3.015D-09,6.579D-08,1.346D-05,1.155D-04,1.485D-03,
     1              1.706D-02,3.089D-02,2.111D-01,2.909D-01,4.152D-01,
     2              4.103D-01,4.074D-01,5.229D-01,5.109D-01,5.424D-01,
     3              5.583D-01,5.543D-01,6.011D-01,6.077D-01,6.339D-01,
     4              6.374D-01,6.426D-01,6.512D-01,6.587D-01/
      DATA DFVC   /1.573D-11,1.103D-10,2.404D-09,2.031D-08,2.041D-06,
     1              7.435D-06,6.753D-04,1.454D-03,3.721D-02,6.425D-02/
      END



C
C	Main-Program
C
C       Program calculates PDR of a finite plane-parallel slab.
C       
C       Assumptions: Isothermal structure, symmetric radiation field,
C                    or UV radiation field is zero on one side.
C                
C
C       Parameter: NLHT = Vib. Levels in ground state of H2
C                  Maximum of NLHT = 15
C                  NPAR = Number of species + H + H2
C                  NR   = right-hand sides for initial-value-solver
C                  NMAX1 = HILFSFELDER 
C                  Ntrans = number of transitions
C
C                  CD(1)      = Colummn-density H2
C                  CD(2)      = Colummn-density H
C                  CD(3-17)   = Column-density H2-vibrational-levels
C                  CD(18-68)  = Column-density of different species
C                               (see DATA SS) !! check DATA S1 (0:51)
C                               CD was expanded afterwards
C                  CD(69-118)  = Column-density of 12CO-levels
C                  CD(119-121) = Three-Level Oxygen-Atom
C                  CD(122-123) = Two-Level C+-Atom
C                  CD(124-126) = Three-Level C-Atom
C                  CD(127-176) = Column-denstiy of 13CO-levels
C                  CD(177-196) = Column-density N_dust(theta)
C                  CD(197-216) = Column-density N_12CO(theta)
C                  CD(217-236) = Column-density N_13CO(theta)
C                  CD(237-256) = Column-density H_2'v=1'(theta)
C                  CD(257-258) = Two-Level Si+-Atom
C                  CD(259-261) = Three-Level 13C-Atom
C                  CD(262-263) = Two-Level 13C+-Atom
C                  CD(264-279) = Sixteen-Level OH molecule
C                  CD(280-310) = 31-Level Ortho-H2O molecule
C                  CD(311-326) = 16-Level Para-H2O  molecule
C                  CD(327-337) = Column-density of 18o species	
C                  CD(338)     = Column-density of 16o18o
C                  CD(339-341) = Column-density of 13c18o species

C                  CD(342-361) = Column-density N_CO18(theta)
C                  CD(362-381) = Column-density N_C13O18(theta) 
CMR...
CMR...  M.Roellig 25.03.2003
CMR........................................................................
CMR...  List of Species in CD/CDD
CMR...  * denotes 13C isotope
CMR...  ^ denotes 18O isotope
CMR...  lower case letters denote species which are not calculated in the new
CMR...                     chemical network which is represented in the DATA 
CMR...                     ARRAY SS or S1
CMR...  capital letters are actually used in the calculations
CMR...  18  He      19  C       20  O       21  H+     22  H2+    23  H3+
CMR...  24  He+     25  CH      26  ch2     27  ch3    28  ch4    29  C+
CMR...  30  CH+     31  CH2+    32  ch3+    33  ch4+   34  ch5+   35  OH
CMR...  36  H2O     37  O+      38  OH+     39  H2O+   40  H3O+   41  CO
CMR...  42  CO+     43  HCO+    44  Electr  45  O2     46  o2+    47  o2h+
CMR...  48  *C      49  *CH     50  *ch2    51  *ch3   52  *ch4   53  *C+
CMR...  54  *CH+    55  *CH2+   56  *ch3+   57  *ch4+  58  *ch5+  59  *CO
CMR...  60  *CO+    61  *HCO+
CMR...  327 C^O     328 C^O+    329 HC^O+   330 ^O     331 ^OH    332 H2^O
CMR...  333 ^O2     334 ^O+     335 ^OH+    336 H2^O+  337 H3^O+  338 O^O
CMR...  339 *C^O    340 *C^O+   341 H*C^O+
CMR...
CMR...  NSP : number of species is set to 45 (used to be 51),
CMR...        all loops running from 1 to 51 have to be changed.
CMR...




C       AENDERUNGEN : STOSSRATEN in COLVIB
C
C
C 


      Parameter(NLHT=15)
      Parameter(NMAX1=800)
      Parameter(NPAR=416)
      Parameter(NCO=50)
      Parameter(NTRANS=476)
      PARAMETER (N1=50,N2=50,N3=100,N4=30,N5=500,NSP=45)	
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      
      DIMENSION CD(NLHT+NPAR),CDD(NLHT+NPAR),EPS(NLHT+NPAR),
     >            YSCAL(NLHT+NPAR),CDDST(NMAX1,NLHT+NPAR),
     >            CD3ST(NMAX1,NLHT+NPAR),ZGST(NMAX1),
     >            XHELP(NMAX1,NLHT+NPAR),ZG2(NMAX1),ZG1(NMAX1),
     >            ZGSTS(NMAX1),Ebalpr(18),CDNEW(NLHT+NPAR),
     >            CDOLD(NLHT+NPAR),CONV(NLHT+NPAR), xspb1(NSP) 

     
      COMMON /MATRIX/ POPA(NLHT,NLHT),POPP(NLHT),POPC(NLHT,NLHT)
      Common/PARAM/ XNTOT,SIGD,ZTOT,SINTL,SINTR,COSRAY,BETA,
     >                STEP1,STEP2,HTRY,RATDG,RFORM,THRES
      Common/Xint/ XHELP,ZG1,NARZ,ITER
      Common/Xfrac/ HEFRAC,OfRAC,CFRAC,SIFRAC,C13FRAC
      Common/Xtest/ TD1,RFORM1,DCOL12CO,DCOL13CO
      Common/Xprint/ Ebalpr

      character *7 name1(8),name2(7), name11(12), name22(4)
      character*16 outname1, outname4
      character*19 outname2
      character*20 outname3
      character*17 outname5
      
      CHARACTER*5 S1(0:NSP)

      data name1/'/','xntot','sintl','ztot','step1','step2',' T ',
     + 'thres'/
      data name2/'/','htry','Hefrac','Ofrac','Cfrac','Sifrac',
     + 'C13frac'/
      data name11/'xntot','sigd','sintl','sintr','ztot','cosray',
     + 'beta','Temp','step1','step2','htry','thres'/
      data name22/'Hefrac','Ofrac','Cfrac','C13frac'/
CMR...
CMR... Array S1 doesn't match the array SS. numerical and alphanumerical
CMR... species identifier are different.
CMR...
CMR...       DATA S1/'/','HE','C','O','H+','H2+','H3+','HE+','CH','CH2','CH3',
CMR...     >          'CH4','C+','CH+','CH2+','CH3+','CH4+','CH5+',
CMR...     >          'OH','H2O','O+','OH+','H2O+','H3O+','CO','CO+',
CMR...     >          'HCO+','ELEC','O2','O2+','O2H+',
CMR...     >          '*C','*CH','*CH2','*CH3','*CH4','*C+','*CH+','*CH2+',
CMR...     >          '*CH3+','*CH4+','*CH5+','*CO','*CO+','*HCO+',
CMR...     >          'Si','Si+','SiO','SiO+','SiH','SiH2+','HOSi+'/
      DATA S1/'/','HE','HE+','H+','H2+','H3+','C','CH','CO','C+',
     >           'CH+','CH2+','CO+','HCO+','*C','*CH','*CO','*C+',
     >           '*CH+','*CH2+','*CO+','*HCO+','O','OH','H2O','O2',
     >           'O+','OH+','H2O+','H3O+','ELEC','^CO','^CO+',
     >           '^HCO+','^O','^OH','^H2O','^O2','^O+','^OH+',
     >           '^H2O+','^H3O+','O^O','*C^O','*C^O+','H*C^O+' /

 
      EXTERNAL HLEV

      write(*,*) "los gehts"
      Call Input(XNTOT,SIGD,ZTOT,SINTL,SINTR,COSRAY,BETA,T,STEP1,
     +     STEP2,HTRY,THRES)

CB 07.11.1995 neuer output nach dem Vorbild der *.out outputs des
CB isotropen Models (ModelA im paper)

      MS=10.0*LOG10(SINTL)
      MD=10.0*LOG10(XNTOT)
      MR=(xntot*ztot*sigd)/4
      MT = beta/10000.0
      
      outname1(1:4) = 'dens'
      outname2(1:7) = 'coldens'
      outname3(1:8) = 'heatcool'
      outname4(1:4) = 'temp'
      outname5(1:5) = 'model'
      
      write(outname1(5:6), 336) MS
      write(outname2(8:9), 336) MS
      write(outname3(9:10), 336) MS
      write(outname4(5:6), 336) MS
      write(outname5(6:7), 336) MS
      write(outname1(7:8), 336) MD
      write(outname2(10:11), 336) MD
      write(outname3(11:12), 336) MD
      write(outname4(7:8), 336) MD
      write(outname5(8:9), 336) MD
      write(outname1(9:10), 336) MR
      write(outname2(12:13), 336) MR
      write(outname3(13:14), 336) MR
      write(outname4(9:10), 336) MR
      write(outname5(10:11), 336) MR
      write(outname1(11:12), 336) MT
      write(outname2(14:15), 336) MT
      write(outname3(15:16), 336) MT
      write(outname4(11:12), 336) MT
      write(outname5(12:13), 336) MT
      outname1(13:16) = '.out'
      outname2(16:19) = '.out'
      outname3(17:20) = '.out'
      outname4(13:16) = '.out'
      outname5(14:17) = '.out'

 336  FORMAT (I2)
      OPEN(41,file=outname1)
      OPEN(42,file=outname2)
      OPEN(43,file=outname3)
      OPEN(44,file=outname4)
      OPEN(45,file=outname5)
CB 07.11.95

C       Changes for AIX370-VERSION
C       Call Xuflow(0)

CMR...
CMR... Open all files
      Call Opnin
CBB ************************************************************** 
CB output: min.out	write(26,*)'  ****************  Inputdaten:  *****************'
CB 06.08.1996	write(26,917) (name1(i),i = 2,7)
CB	write(26,916) xntot,sintl,ztot,step1,step2,T
CB	write(26,917) (name2(i),i = 2,7)
CB	write(26,916) htry,hefrac,ofrac,cfrac,sifrac,c13frac
CB	write(26,*) 'threshold = ',thres,'eV'
CB	write(26,*)'  ************************************************'
cm	write(11,*)'  ****************  Inputdaten:  *****************'
cm	write(11,917) (name1(i),i = 2,7)
 917  format(6(a11))
cm	write(11,916) xntot,sintl,ztot,step1,step2,To
 916  format(6(1X,1pe10.3))
cm	write(11,917) (name2(i),i = 2,7)
cm	write(11,916) htry,hefrac,ofrac,cfrac,sifrac,c13frac
cm	write(11,*) 'threshold = ',thres,'eV'	
cm	write(11,*)'  ************************************************'
      write(35,*)'  ****************  Inputdaten:  *****************'
      write(35,917) (name1(i),i = 2,7)
      write(35,916) xntot,sintl,ztot,step1,step2,T
      write(35,917) (name2(i),i = 2,7)
      write(35,916) htry,hefrac,ofrac,cfrac,sifrac,c13frac
      write(35,*) 'threshold = ',thres,'eV'
      write(35,*)'  ************************************************'
      
      write(45,*)'  ****************  Inputdaten:  *****************'
      write(45,917) (name11(i),i = 1,6)
      write(45,916) xntot,sigd,sintl,sintr,ztot,cosray
      write(45,917) (name11(i),i = 7,12)
      write(45,916) beta,t,step1,step2,htry,thres 
      write(45,917) (name22(i),i = 1,4)
      write(45,916) hefrac,ofrac,cfrac,c13frac
      write(45,*)'  ***********************************************'
      
      THELP = T
      HHELP = HTRY
CMR...
CMR... read atomar data
      Call Eread
      NR = NLHT+NPAR
CMR...
CMR... initialize arrays CD, CDD to zero
      CALL XIN(CD,CDD,NR)
CMR...
CMR... write array POPA with A-values
      Call LQDVIB
CMR...
CMR... read in chemical network
      CALL CMREAD(XNTOT,CFRAC,OFRAC,HEFRAC) 
CMR...
CMR... read in CO data (self shielding, energy levels,
CMR...  A-values, CO-H2 collision matrix
      CALL COLOAD
C       Noch abaendern in HLEV 
C       H2-formation rate in cm**3/sec
C       RFORM  =  3.0d-17
C       ITERATION LOOP      
      Do 40 ITER = 1,15	

CB ********* Linienintensitaeten nach j-ter. Iteration :******
c	if (iter.eq.6) then
c	Av = (xntot*ztot*sigd)/4
CBC calculating CO-intensities
c      Call XLine(CDDST,ZGST,NAKT,BETA,
c     >    AV,XNTOT,SINTL,zg2) 
CBC calculating C, CII und O intensities
c      Call XLine1(CDDST,ZGST,NAKT,BETA,
c     >    AV,XNTOT,SINTL,zg2) 
CBC   Sprung an das Programmende
c	  goto 115
c	endif
CB **************************************************


CB Konvergenzabfrage, 08.10.1992:

         if (iter.eq.1) then
            do 117 j = 1,(NLHT + NPAR)
               cdnew(j) = 0.0d0
               cdold(j) = 0.0d0
 117        continue
         endif
         if (iter.gt.1) then
            do 111 j = 1,(NLHT + NPAR)	
               cdold(j) = cdnew(j)
               cdnew(j) = cd(j)
               diff = abs(cdold(j) - cdnew(j))
               if (cdnew(j).gt.0.0) then 
                  conv(j) = diff/cdnew(j)
               else 
                  conv(j) = 0.0d0
               endif
 111        continue	
            do 116 k = 1,(NLHT + NPAR)
 116        continue		 
            write(*,*) '116'
            do 112 j = 1,(NLHT + NPAR) 
               if (conv(j).ge.0.01) then
CB Sprung in den weiteren Programmablauf, keine Konvergenz!!
                  goto 113
               end if
 112        continue
            
            write(*,*) 'Konvergenz nach',(iter-1),' Iterationen!!'
CB    xline-Aufruf!!

CMR...
CMR... Roberge et.al. 1991 
            Av = (xntot*ztot*sigd)/4
CBC	calculating co-intensities
            Call XLine(CDDST,ZGST,NAKT,BETA,
     >          AV,XNTOT,SINTL,zg2) 
CBC	calculating C, CII and O-itensities
cm          Call XLine1(CDDST,ZGST,NAKT,BETA,
cm     >    AV,XNTOT,SINTL,zg2) 


CB Sprung ans Ende des Programms!!
            goto 115
         endif
CB ************ Ende der Konvergenzabfrage ***************


CB	write(10,*) ',Iteration =', iter
 113     continue
         Do 30 i = 1,NMAX1
            Do 35 j = 1,NLHT+NPAR
               xhelp(i,j) = 0.0d0
               if(cd3st(i,j).gt.1.0d7) then	
                  XHELP(i,j) = CD3ST(i,j)
               endif
               CD3ST(i,j) = 0.0d0
 35         continue
            ZG1(i)   = ZGST(i)
            ZG2(i)   = ZGST(i)
            ZGST(i)  = 0.0d0
 30      continue
CB 07.11.1995
         write(*,*) outname1
         write(*,*) outname2
         write(*,*) outname3
         write(*,*) outname4
         write(*,*) outname5
CB 07.11.95
         rewind 11
         rewind 10
         rewind 14
         rewind 16
cm	rewind 27
cm	rewind 28
cm	rewind 29
cm	rewind 31
cm	rewind 32
cm	rewind 33
cm       rewind 34
cm	rewind 36
cm	rewind 37
cm	rewind 38
cm	rewind 39
CB	rewind 35
         rewind 80
         rewind 41
         rewind 42
         rewind 43
         rewind 44

CMR...
CMR... starting values for the chemical network
         CALL CMREAD1(XNTOT,CFRAC,OFRAC,HEFRAC) 
CMR...
CMR... initialize CD, CDD with zero
         CALL XIN(CD,CDD,NR)

         CH2    = 0.0d0
         CVJDEN = 0.0d0
C         START-VALUES for densities in 1/cm**3
         HDEN  = XNTOT/3.0d0
         H2DEN = XNTOT/3.0d0
         CDD(1) = H2DEN
         CDD(2) = HDEN
         ZG = 0.0d0 
         If(NLHT.gt.15) Call Errors(1)
         CALL FABVIB(BETA)
CB *****************************************************************

         T = THELP

         Call HLEV(ZG,CD,CDD,NR,T,HDEN,H2DEN)

         Write(*,131) 0.0d0,HTRy,ZG,CD(1),CD(2),0,
     >                 CDD(41),CD(41),t

         Call HLEV(ZG,CD,CDD,NR,T,HDEN,H2DEN)
CB *************************************************************

      
         HNEXT    = HHELP
         HTRY = HHELP
         WRITE(*,*) 'ITERATION = ', ITER
         Do 45 j = 1,NLHT+NPAR
            CD3ST(1,j) = 0.0d0
            CDDST(1,j) = CDD(j)
c	write(*,*) 'cdd(',j,') = ', cdd(j)
 45      continue     
         ZGST(1)  = 0.0d0
         ZGSTS(1) = 0.0d0
         ZTOT2    = ZTOT/2.0d0
         NSTEP    = 500
         write(*,141)
CB          Write(*,140) 
         Write(*,131) 0.0d0,HTRy,ZG,CD(1),CD(2),0,
     >                 CDD(41),CD(41),t
 
CB         Write(*,130) 0.0d0,HTRy,ZG,CD(1),CD(2),CDD(1),CDD(2),0,
CB     >                 CD(3),CDD(41),CD(41)
CB          Write(*,180) T 
         av1 = (xntot*zg*sigd)/4.0d0
         Call Output(ZG,CD,CDD,Iter,T,xntot,av1)
C     First Half of slab
         Do 10 istep = 1,1+(NSTEP-1)/2
            av1 = (xntot*zg*sigd)/4.0d0
            KK = 0
            Do 20 i = 1,NR
               YSCAL(i) = CD(i)+HTRY*CDD(i)+1.0d-21*HNEXT
               EPS(i)   = 1.0d-1
               IF(i.gt.68.and.i.lt.119) then 
                  IF(CDD(i).gt.1.0d-12) then
                     YSCAL(i) = CD(i)+HTRY*CDD(i)+1.0d-21*HNEXT
                  Else 
                     YSCAL(i) = CD(41)+HTRY*CDD(41)+1.0d-21*HNEXT
                  ENDIF
               ENDIF
               IF(i.gt.126.and.i.lt.177) then 
CB                 EPS(i) = 1.0d1
CB                   EPS(i) = 1.0d-1
                  IF(CDD(i).gt.1.0d-12) then
                     YSCAL(i) = CD(i)+HTRY*CDD(i)+1.0d-21*HNEXT
                  Else 
                     YSCAL(i) = CD(59)+HTRY*CDD(59)+1.0d-21*HNEXT
                  ENDIF
               ENDIF

cm new
               IF(i.gt.366.and.i.lt.417) then 
                  IF(CDD(i).gt.1.0d-12) then
                     YSCAL(i) = CD(i)+HTRY*CDD(i)+1.0d-21*HNEXT
                  Else 
                     YSCAL(i) = CD(327)+HTRY*CDD(327)+1.0d-21*HNEXT
                  ENDIF
               ENDIF
     
C              IF(i.gt.123.and.i.lt.127) then
C                YSCAL(i) = CD(19)+HTRY*CDD(19)+1.0d-21*HNEXT
C              Endif
 20         continue
            CALL BSSTEP(CD,CDD,NR,NR,ZG,HTRY,EPS,YSCAL,HDID,HNEXT,
     >                  HLEV,T,HDEN,H2DEN,KK)
CB             write(*,*) 'cd(3), cdd(3)=',cd(3),cdd(3)

C alt       Do 15 j=1,NLHT+NPAR
C              CD3ST(istep+1,j) = CD(j)
C              CDDST(istep+1,j) = CDD(j)
C15          continue
            ZGST(istep+1)  = ZG
            ZGSTS(istep+1) = ZG
            NAKT           = istep+1
C           Write(*,140) 
C           Write(*,130) HDID,HNEXT,ZG,CD(1),CD(2),CDD(1),CDD(2),KK,
C    >                   CD(3)
            Call HLEV(ZG,CD,CDD,NR,T,HDEN,H2DEN)
            Do 15 j=1,NLHT+NPAR
               CD3ST(istep+1,j) = CD(j)
               CDDST(istep+1,j) = CDD(j)
CB	write(*,*) 'cdd(',j,') =', cdd(j)
 15         continue
            Call Output(ZG,CD,CDD,Iter,T,xntot,av1)
            TAUDL = XNTOT*sigd*ZG
            TAUDR = XNTOT*sigd*(ZTOT-ZG)
CB	if ((iter.ge.5).and.(zg.le.ztot/2.0)) then
CB10.11.93       Call CMSRTB(MSTP,T,SINTL,SINTR,TAUDL,TAUDR,HDEN,H2DEN,
CB     >             COSRAY,CD,COLR,NR)
CB	endif

            Write(*,131) HDID,HNEXT,ZG,CD(1),CD(2),KK,
     >                   CDD(41),CD(41),t

            HTRY     = HNEXT
            If((ZG+Hnext).Ge.(Ztot2-Ztot2/1000.d0)) then
               HTRY=Ztot2-ZG-Ztot2/1.0d8
            Endif
CB  **************  IF ABFRAGE: STEP1,STEP2  ***************************          
CB Hier die Schrittweitenbedingung abaendern 
            QUOT = (xntot*cfrac)/CDD(41)
            DDD = 1.01d0
            IF (QUOT.GT.DDD) THEN
               Htry=Min(Ztot2/STEP1,Htry)
            END IF
           
            IF (QUOT.LE.DDD) THEN
               Htry=Min(Ztot2/STEP2,Htry)
CB      	write(*,*) STEP2
            END IF 
CB ***** !!!!  Zusatzbedingung fuer kleine Schrittweiten !!! **********
            IF (iter.ge.1) then
               READ(30,34,end = 33) Z1MIN,Z1MAX,HT1,Z2MIN,Z2MAX,HT2,
     +             Z3MIN,Z3MAX,HT3,Z4MIN,Z4MAX,HT4	
34	  FORMAT(/,/,/,/,/,e17.10,/,/,e17.10,/,/,e17.10,/,/,e17.10,
     + /,/,e17.10,/,/,e17.10,/,/,E17.10,/,/,E17.10,/,/,E17.10,
     +/,/,e17.10,/,/,e17.10,/,/,e17.10)
 33            continue 

               IF ((ZG.GE.Z1MIN).and.(ZG.LT.Z1MAX)) THEN
                  HTRY = MIN(HT1,HTRY)
               END IF 
               IF ((ZG.GE.Z2MIN).AND.(ZG.LT.Z2MAX)) THEN
                  HTRY = MIN(HT2,HTRY)
               END IF 
               IF ((ZG.GE.Z3MIN).and.(ZG.LT.Z3MAX)) THEN
                  HTRY = MIN(HT3,HTRY)
               END IF 
               IF ((ZG.GE.Z4MIN).and.(ZG.LT.Z4MAX)) THEN
                  HTRY = MIN(HT4,HTRY)
               END IF
            END IF
            If((abs(ZG-Ztot2)/Ztot2).lt.0.0001d0) then
               write(*,*) 'Normally ended'
               Goto 250
            endif
           
C           WRITE(*,160) CD(19)
 10      continue
 250     continue 
         NSTEP = NAKT+NAKT-1 
C         stop


C                    Second Half of slab

         write(*,*) '   ************  second half *******************'
         write(*,141)
CB ***********
CB 	zhelp2 = ztot2/20
         Do 50 istep = NAKT+1,NSTEP
            av1 = (xntot*zg*sigd)/4.0d0
            KK = 0
            
            HTRY = ZGSTS(NSTEP-Istep+2)-ZGSTS(NSTEP-Istep+1)

            Do 60 i = 1,NR
               YSCAL(i) = CD(i)+HTRY*CDD(i)+1.0d-21*HNEXT
               EPS(i)   = 1.0d-3
               IF(i.gt.68.and.i.lt.119) then 
                  IF(CDD(i).gt.1.0d-12) then
                     YSCAL(i) = CD(i)+HTRY*CDD(i)+1.0d-21*HNEXT
                  Else 
                     YSCAL(i) = CD(41)+HTRY*CDD(41)+1.0d-21*HNEXT
                  ENDIF
               ENDIF
               IF(i.gt.126.and.i.lt.177) then 
                  EPS(i) = 1.0d-1
                  IF(CDD(i).gt.1.0d-12) then
                     YSCAL(i) = CD(i)+HTRY*CDD(i)+1.0d-21*HNEXT
                  Else 
                     YSCAL(i) = CD(59)+HTRY*CDD(59)+1.0d-21*HNEXT
                  ENDIF
               ENDIF

cm
               IF(i.gt.366.and.i.lt.417) then 
                  EPS(i) = 1.0d-1
                  IF(CDD(i).gt.1.0d-12) then
                     YSCAL(i) = CD(i)+HTRY*CDD(i)+1.0d-21*HNEXT
                  Else 
                     YSCAL(i) = CD(327)+HTRY*CDD(327)+1.0d-21*HNEXT
                  ENDIF
               ENDIF


	      
 60         continue
CB 26.08.92
            if (istep .gt. nstep-10) then 
               T = 150 
            end if
            CALL BSSTEP(CD,CDD,NR,NR,ZG,HTRY,EPS,YSCAL,HDID,HNEXT,
     >          HLEV,T,HDEN,H2DEN,KK)
            ZGST(istep)  = ZG
            NAKT           = istep
            Call HLEV(ZG,CD,CDD,NR,T,HDEN,H2DEN)
           
            Do 55 j=1,NLHT+NPAR
               CD3ST(istep,j) = CD(j)
               CDDST(istep,j) = CDD(j)
 55         continue
            Call Output(ZG,CD,CDD,Iter,T,xntot,av1)
            
            Write(*,131) HDID,HNEXT,ZG,CD(1),CD(2),KK,
     >                   CDD(41),CD(41),t
            HTRY     = HNEXT
            If((abs(ZG-Ztot)/Ztot).lt.0.0001d0) then
               write(*,*) 'zg = ',zg
               write(*,*) 'ztot = ',ztot
               write(*,*) 'Normally ended'
               Goto 350
            endif
 50      continue
         write(*,*) 'diff =',(abs(ZG-Ztot)/Ztot)	 
         Call Errors(2)
 350     continue

         NARZ = NAKT
 40   continue        

CMR...110     Format(5x,'HDEN =',e17.10,'   H2DEN =',e17.10)
CMR...120	format(16(e8.2),/)
 131  format(5(1x,e12.5),1x,i3,3(1x,e12.5))
CMR...130     format(1x,7(1x,e12.5),1x,i3,3(1x,e12.5))
 141  format(5x,'HDID',9x,'HNEXT',11x,'z',11x,'NH2',10x,'NH1',
     >         6x,'kk',
     >         6x,'nCO',9x,'NCO',6x,'temperature')
CMR...140     format(6x,'HDID',9x,'HNEXT',11x,'z',11x,'NH2',10x,'NH1',
CMR...     >         9x,'nH2',10x,'nH1',6x,'kk',4x,'NH2ground',
CMR...     >	     6x,'nCO',9x,'NCO')
CMR.....^unklar ob Korrektur richtig
CMR...150     format(1x,e12.5)
CMR...160     Format('C-Column-Density: ',e12.5)
CMR...170     format(5(e12.5))
CMR...180     format('Temperature:',e12.5)
 115  continue
CB07.11.1995 ***********************************************************
CB          write(115,*) '***********************************************'
CMR... in order to print out the correct column densities the vector xspb1 
CMR... has to be set by hand.
      xspb1(1) = CD(1+17)
      xspb1(2) = CD(7+17)
      xspb1(3) = CD(4+17)
      xspb1(4) = CD(5+17)
      xspb1(5) = CD(6+17)
      xspb1(6) = CD(2+17)
      xspb1(7) = CD(8+17)
      xspb1(8) = CD(24+17)
      xspb1(9) = CD(12+17)
      xspb1(10) = CD(13+17)
      xspb1(11) = CD(14+17)
      xspb1(12) = CD(25+17)
      xspb1(13) = CD(26+17)
      xspb1(14) = CD(31+17)
      xspb1(15) = CD(32+17)
      xspb1(16) = CD(42+17)
      xspb1(17) = CD(36+17)
      xspb1(18) = CD(37+17)
      xspb1(19) = CD(38+17)
      xspb1(20) = CD(43+17)
      xspb1(21) = CD(44+17)
      xspb1(22) = CD(3+17)
      xspb1(23) = CD(18+17)
      xspb1(24) = CD(19+17)
      xspb1(25) = CD(28+17)
      xspb1(26) = CD(20+17)
      xspb1(27) = CD(21+17)
      xspb1(28) = CD(22+17)
      xspb1(29) = CD(23+17)
      xspb1(30) = CD(27+17)
      xspb1(31) = CD(310+17)
      xspb1(32) = CD(311+17)
      xspb1(33) = CD(312+17)
      xspb1(34) = CD(313+17)
      xspb1(35) = CD(314+17)
      xspb1(36) = CD(315+17)
      xspb1(37) = CD(316+17)
      xspb1(38) = CD(317+17)
      xspb1(39) = CD(318+17)
      xspb1(40) = CD(319+17)
      xspb1(41) = CD(320+17)
      xspb1(42) = CD(321+17)
      xspb1(43) = CD(322+17)
      xspb1(44) = CD(323+17)
      xspb1(45) = CD(324+17)
CMR...          Do 107 i = 1,51
CB          Do 107 i = 1,44
CMR...           xspb1(i) = CD(I+17)
CMR...107       continue
      WRITE(45,622)
 622  FORMAT(/,10X,'CHEMICAL COLUMN DENSITIES')
CMR...         WRITE(45,625) (S1(I),xspb1(I), I=1,51)
      WRITE(45,625) (S1(I),xspb1(I), I=1,45)
 625  FORMAT(4(A5,1X,1PE10.3,2X))

      WRITE(45,930) CD(1),CD(2) 
 930  FORMAT(/,4X,' H2 COLUMN DENSITY =',1PE10.3,
     1     '  H COLUMN DENSITY =',1PE10.3,/)

      WRITE(45,978)	
 978  FORMAT(/,20X,'H2 COLUMN DENSITIES')
      WRITE(45,970) (CD(I), I=3,17)
 970  FORMAT(5(2X,1PE10.3))
      
      WRITE(45,968)
 968  FORMAT(/,20X,'12CO LEVEL COLUMN DENSITIES')
      WRITE(45,970) (CD(I), I=69,118)
      
      WRITE(45,938)
 938  FORMAT(/,20X,'13CO COLUMN DENSITIES')
      WRITE(45,970) (CD(I), I=127,176)
      
CB          write(115,*) '***********************************************'
      write(45,*) ' '
      WRITE(45,977) CD(124),CD(125),CD(126)
 977  Format('CI-Column-Densities',3(1x,e12.5))

CB *************************************************************************


      End

      SUBROUTINE OPNIN
C
C       Opens the various input files.
C
cm        OPEN(1,file='avibnew.dat')
cm        OPEN(2,file='cdata.dat')
cm        OPEN(3,file='ex.dat')
cm        OPEN(4,file='bdata.dat')
c        OPEN(88,file='pdr.inp',STATUS='old')
cm 	OPEN(10,file='line_int.dat')
cm        OPEN(11,file='pdr.out1')
cm        OPEN(12,file='cospl.dat')
cm        OPEN(13,file='codat.dat')
cm        OPEN(14,file='test.dat')
cm        OPEN(16,file='selfsh13.dat')
CB06.08.1996	OPEN(26,file='min.out',STATUS='OLD')
cm	OPEN(27,file='plot_T.dat')
cm	OPEN(28,file='plot_CC.dat')
cm	OPEN(29,file='plot_rat.dat')
cm	OPEN(30,file='htry.min')
cm  	OPEN(31,file='plot_cool1.dat')
cm	OPEN(32,file='plot_reaktionen.dat')	
cm	OPEN(33,file='plot.int')
cm	OPEN(34,file='plot_columnratio.dat')
cm	OPEN(36,file='plot_heat1.dat')
cm	OPEN(37,file='plot_dcol.dat')
cm	OPEN(38,file='plot.den1')
cm	OPEN(39,file='plot.den2')
cm	OPEN(35,file='int.out1')
cmm       mein chemie-file 	
cm        OPEN(75,file='rcisonew.dat')
cm	OPEN(80,file='chemie.dat')

      OPEN(1,file='avibnew.dat')
      OPEN(2,file='cdata.dat')
      OPEN(3,file='ex.dat')
      OPEN(4,file='bdata.dat')
c        OPEN(88,file='pdr.inp',STATUS='old')
      OPEN(10,file='line_int.dat')
cm        OPEN(11,file='pdr.out1')
      OPEN(12,file='cospl.dat')
      OPEN(13,file='codat.dat')
cm        OPEN(14,file='test.dat')
cm        OPEN(16,file='selfsh13.dat')
CB06.08.1996	OPEN(26,file='min.out',STATUS='OLD')
cm	OPEN(27,file='plot_T.dat')
cm	OPEN(28,file='plot_CC.dat')
cm	OPEN(29,file='plot_rat.dat')
      OPEN(30,file='htry.min')
cm  	OPEN(31,file='plot_cool1.dat')
cm	OPEN(32,file='plot_reaktionen.dat')	
cm	OPEN(33,file='plot.int')
cm	OPEN(34,file='plot_columnratio.dat')
cm	OPEN(36,file='plot_heat1.dat')
cm	OPEN(37,file='plot_dcol.dat')
cm	OPEN(38,file='plot.den1')
cm	OPEN(39,file='plot.den2')
      OPEN(35,file='int.out1')
cmm       mein chemie-file 	
      OPEN(75,file='rcisonew.dat')
      OPEN(80,file='chemie.dat')
        
      RETURN
      END 
C                                                               
C                                                                       
      SUBROUTINE EREAD  
C
C      Input of atomic data
C                                           
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      COMMON /ENERGY/ EX(15),EB(24),EC(10)                         
      COMMON /BANDB/ FBANDB(0:14,0:23),AVBTOT(0:23),ABCONT(0:23),      
     >                DFVB(0:23)                                        
      COMMON /BANDC/ FBANDC(0:14,0:9),DFVC(0:9)                        
C      BLOCK DATA
C       DATA AVBTOT /1.868D+09,1.741D+09,1.632D+09,1.536D+09,1.450D+09,
C     1              1.372D+09,1.301D+09,1.236D+09,1.177D+09,1.122D+09,
C     2              1.072D+09,1.025D+09,9.804D+08,9.391D+08,9.003D+08,
C     3              8.640D+08,8.301D+08,7.990D+08,7.702D+08,7.439D+08,
C     4              7.199D+08,6.981D+08,6.783D+08,6.598D+08/
C       DATA ABCONT /5.632D+00,1.145D+02,2.197D+04,1.774D+05,2.153D+06,
C     1              2.341D+07,4.019D+07,2.609D+08,3.424D+08,4.659D+08,
C     2              4.398D+08,4.176D+08,5.127D+08,4.798D+08,4.883D+08,
C     3              4.824D+08,4.601D+08,4.803D+08,4.681D+08,4.716D+08,
C     4              4.589D+08,4.486D+08,4.417D+08,4.346D+08/
C       DATA DFVB   /3.015D-09,6.579D-08,1.346D-05,1.155D-04,1.485D-03,
C     1              1.706D-02,3.089D-02,2.111D-01,2.909D-01,4.152D-01,
C     2              4.103D-01,4.074D-01,5.229D-01,5.109D-01,5.424D-01,
C     3              5.583D-01,5.543D-01,6.011D-01,6.077D-01,6.339D-01,
C     4              6.374D-01,6.426D-01,6.512D-01,6.587D-01/
C       DATA DFVC   /1.573D-11,1.103D-10,2.404D-09,2.031D-08,2.041D-06,
C     1              7.435D-06,6.753D-04,1.454D-03,3.721D-02,6.425D-02/
   
      DO 10, I=1,15
         READ(3,8) EX(I)
 8       FORMAT(1X,E10.3)
 10   CONTINUE
      E1=EX(1)
      DO 11, I=1,15
         EX(I)=EX(I)-E1
 11   CONTINUE
C
C                                                                      
      H=0.0d0                                                             
      DO 90, NV=0,23                                                   
         READ(4,80) T                                              
 80      FORMAT(4E12.4)                                                
         EB(NV+1)=T                                                 
 90   CONTINUE                                                         
      DO 100, NVX=0,14                                                 
         READ(4,95) (FBANDB(NVX,NVB), NVB=0,23) 
 95      FORMAT(8E10.3)                                                
 100  CONTINUE                                                         
C                                                                       
      DO 130, NV=0,9                                                   
         READ(2,110) T                                             
 110     FORMAT(4E12.4)                                                
         EC(NV+1)=T
 130  CONTINUE                                                         
C                                                                       
      DO 140, NVX=0,14                                                 
         READ(2,135) (FBANDC(NVX,NVC), NVC=0,9)                        
 135     FORMAT(7E10.3)                                                   
 140  CONTINUE                                                         
C                                                                       
      RETURN                                                           
      END                                                              
C
C
      Subroutine HLEV(ZG,CD,CDD,NR,T,HDEN,H2DEN)
C
C      Righthand-side of initial value solver for H2-problem
C
      Parameter(NLHT=15)
      Parameter(NPAR=416)
      Parameter(NMAX1=800)      
      PARAMETER(NSP=45)
      PARAMETER(nco=50)
 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
      DIMENSION CD(NR),CDD(NR),XHELP(NMAX1,NLHT+NPAR),
     >           ZG1(NMAX1),XNSP(NSP),COLR(NLHT+NPAR),
     >           COCOOL(NCO-1)
      INTEGER NARZ,ITER 

      Common/PARAM/ XNTOT,SIGD,ZTOT,SINTL,SINTR,COSRAY,BETA,
     >               STEP1,STEP2,HTRY,RATDG,RFORM,THRES
      COMMON /ENERGY/ EX(15),EB(24),EC(10)
      COMMON /MATRIX/ POPA(NLHT,NLHT),POPP(NLHT),POPC(NLHT,NLHT)
      Common/Xint/ XHELP,ZG1,NARZ,ITER 
      Common/Xfrac/ HEFRAC,OfRAC,CFRAC,SIFRAC,C13FRAC
      Common/Xtest/ TD1,RFORM1,DCOL12CO,DCOL13CO
        
C
      DIMENSION Z(NLHT+1,NLHT+1),VJFRAC(NLHT+1),INDX(NLHT+1)
      DIMENSION ZCOP(NLHT+1,NLHT+1),BP(NLHT+1)
      Do 80 IT = 1,1
         TAUDL = XNTOT*sigd*ZG
         TAUDR = XNTOT*sigd*(ZTOT-ZG)
         Call COLDR(ZG,COLR,ZTOT,XNTOT)
C        New temperature 

CB first iteration isothermical:
CB15.11.93	if (iter.eq.1) then
CB          write(*,*) 'iter = ',iter
CB          T = 30.0d0
CB          CALL HTCL(T,CD,CDD,NR,BETA,SINTL,SINTR,TAUDL,
CB     >          TAUDR,XNTOT,ETOT,COLR,HDEN,H2DEN,COSRAY,THRES)
CB         goto 111
CB	endif

         CALL TCAL(T,CD,CDD,NR,BETA,SINTL,SINTR,TAUDL,
     >             TAUDR,XNTOT,COLR,HDEN,H2DEN,COSRAY,THRES,ITER)
         goto 111

CB ******************** Achtung *******************************
CB Rest des Unterprogramms wird nicht ausgefuehrt!!!!! 

C
C        H2-problem 
         CALL COLVIB(T,HDEN,H2DEN)
C        Call PMAT(NLHT,NLHT,POPA)
         COLH2L = CD(3)
C        Write(*,*) COLR
C        Write(*,*)
         COLH2R = COLR(3) 

         CALL PCLVIB(COLH2L,COLH2R,TAUDL,TAUDR)
C        Call PMAT(NLHT,NLHT,POPA)
         CALL PMPVIB
c        Call Pmat(NLHT,NLHT,POPC)
C        Matrix zur Loesung der Ratengl. aufbauen
         Do 10 i=1,NLHT+1
            VJFRAC(i) = 0.0d0 
            INDX(i)   = 0.0d0
            D         = 0.0d0
            Do 10 j=1,NLHT+1
               Z(i,j) = 0.0d0
 10      continue
         Do 20 i=1,NLHT
            Do 30 j=1,NLHT
               Z(i,j) = Popa(i,j)+Popc(i,j)
 30         continue
            Z(I,I) = Z(i,i)+Cosray
            Z(i,1) = Z(i,1)+POPP(i)
 20      continue
C        Letzte Zeile einbauen
         Do 40 j=1,NLHT
            Z(NLHT+1,j) = 1.0d0
 40      continue
C        Letzte Spalte einbauen (TEST !!!)
         Qform = 0.0d0
         Do 50 i = 1,NLHT
            Qform = Qform+expc2(-EX(i)/12098.0d0)
 50      continue
         CALL SFAC(T,SINTL,SINTR,TAUDL,TAUDR,TD,RFORM)
         TD1    = TD
         RFORM1 = RFORM
C        RFORM  =  3.0d-17
         Do 60 i=1,NLHT
            Z(i,NLHT+1) = (-Rform*XNTOT*expc2(-ex(i)/12098.0d0))
     >                   /Qform
 60      continue
         Z(NLHT+1,NLHT+1) = 0.5d0
         VJFRAC(16)       = 0.5d0 
C        Call Pmat(NLHT+1,NLHT+1,Z)
C
         DO 185, I=1,NLHT+1
            BP(I)=VJFRAC(I)
            DO 184, J=1,NLHT+1
               ZCOP(I,J)=Z(I,J)
 184        CONTINUE
 185     CONTINUE

         Call LUDCMP(Z,NLHT+1,NLHT+1,INDX,D)
         write(*,*) 'kein Ende nach Ludcmp'
         Call LUBKSB(Z,NLHT+1,NLHT+1,INDX,VJFRAC)
C        CALL MPROVE(ZCOP,Z,NLHT+1,NLHT+1,INDX,BP,VJFRAC)

         H2DEN = 0.0d0
         Do 70 i = 1,NLHT+1
            if(i.lt.NLHT+1) H2DEN = H2DEN+XNTOT*VJFRAC(i)
 70      continue
         HDEN  = VJFRAC(16)*XNTOT
         H2DEN = (XNTOT-HDEN)/2.0d0
         CDD(1) = H2den
         CDD(2) = Hden
         Do 90 i = 1,NLHT
            CDD(i+2) = XNTOT*VJFRAC(i)
 90      continue
         CDH2   = CD(1)
         CDCCO  = CD(41)
         CDC    = CD(19)
         CDC13  = CD(48)
         CDC13O = CD(59)


C         Chemical network      
         Call CHEM3(T,SINTL,SINTR,TAUDL,TAUDR,
     >               HDEN,H2DEN,NF,COSRAY,HEFRAC,
     >               OFRAC,CFRAC,SIFRAC,C13FRAC,XNSP,
     >               CD,COLR,NR)
CMR...
CMR...         Do 100 i = 1,NSP 
CMR...            CDD(NLHT+2+I)   = XNSP(I)
CMR... 100      continue
CMR...

         CDD(NLHT+2+1) = XNSP(1)
         CDD(NLHT+2+2) = XNSP(6)
         CDD(NLHT+2+3) = XNSP(22)
         CDD(NLHT+2+4) = XNSP(3)
         CDD(NLHT+2+5) = XNSP(4)
         CDD(NLHT+2+6) = XNSP(5)
         CDD(NLHT+2+7) = XNSP(2)
         CDD(NLHT+2+8) = XNSP(7)
         CDD(NLHT+2+12)= XNSP(9)
         CDD(NLHT+2+13)= XNSP(10)
         CDD(NLHT+2+14)= XNSP(11)
         CDD(NLHT+2+18)= XNSP(23)
         CDD(NLHT+2+19)= XNSP(24)
         CDD(NLHT+2+20)= XNSP(26)
         CDD(NLHT+2+21)= XNSP(27)
         CDD(NLHT+2+22)= XNSP(28)
         CDD(NLHT+2+23)= XNSP(29)
         CDD(NLHT+2+24)= XNSP(8)
         CDD(NLHT+2+25)= XNSP(12)
         CDD(NLHT+2+26)= XNSP(13)
         CDD(NLHT+2+27)= XNSP(30) 
         CDD(NLHT+2+28)= XNSP(25)
         CDD(NLHT+2+31)= XNSP(14)
         CDD(NLHT+2+32)= XNSP(15)
         CDD(NLHT+2+36)= XNSP(17)
         CDD(NLHT+2+37)= XNSP(18)
         CDD(NLHT+2+38)= XNSP(19)
         CDD(NLHT+2+42)= XNSP(16)
         CDD(NLHT+2+43)= XNSP(20)
         CDD(NLHT+2+44)= XNSP(21)
c  _________________________________
         CDD(NLHT+2+310)= XNSP(31) 
         CDD(NLHT+2+311)= XNSP(32)
         CDD(NLHT+2+312)= XNSP(33)
         CDD(NLHT+2+313)= XNSP(34)
         CDD(NLHT+2+314)= XNSP(35)
         CDD(NLHT+2+315)= XNSP(36)
         CDD(NLHT+2+316)= XNSP(37)
         CDD(NLHT+2+317)= XNSP(38)
         CDD(NLHT+2+318)= XNSP(39)
         CDD(NLHT+2+319)= XNSP(40)
         CDD(NLHT+2+320)= XNSP(41)
         CDD(NLHT+2+321)= XNSP(42)
         CDD(NLHT+2+322)= XNSP(43)
         CDD(NLHT+2+323)= XNSP(44)
         CDD(NLHT+2+324)= XNSP(45)


C 111      continue
C        CO-level problem
         Call COLEVS(CD,CDD,H2DEN,HDEN,T,BETA,NR,COCOOL)
 111     continue
CMR....<------  JUMP from beginning of SUBROUTINE
 80   continue
CMR...110    format(1x,i3,1x,e12.5)
CMR...120    Format(5x,'ZG =',e17.10,5x,'HDEN =',e17.10,'H2DEN =',e17.10)
CMR...130    format(5x,'ZG =',e12.5,'XNH2 =',e12.5)
      RETURN
      END
 
C
C
      SUBROUTINE COLVIB(T,HDEN,H2DEN)   
C                                                                       
C      LOADS THE COLLISIONAL TERMS TO THE VIBRATIONAL MATRIX            
C                                         

      Parameter(NLHT=15)                              
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON /MATRIX/ POPA(NLHT,NLHT),POPP(NLHT),POPC(NLHT,NLHT)
C      COMMON /MATRIX/ POPA(15,15),POPP(15),POPC(15,15)
      COMMON /ENERGY/ EX(15),EB(24),EC(10)                         
C                                                                       
C      INITIALIZE ARRAY POPC TO ZERO.                                   
      DO 20, I=1,NLHT
         DO 10, J=1,NLHT      
            POPC(I,J)=0.D0  
 10      CONTINUE                                                      
 20   CONTINUE    
 
C                                                                       
 58   IF (T .GE. 0.) THEN                                            
C      HDEN+2*H2DEN ?
         COL2=5.4D-13*(HDEN+H2DEN)*T**0.5D0
CB     COL2=5.4D-13*(XNTOT)*T**0.5D0
         HTOT=HDEN+2*H2DEN
         CMF=6.950083D-01
         DO 70, NV=1,NLHT-1
            DE=EX(NV+1)-EX(NV)                            
CC                COL=(CH*HDEN+CH2*H2DEN*expc2(-6.01*DE/(T+1190.D0)))*NV
            COL=COL2*NV
            POPC(NV+1,NV+1)=POPC(NV+1,NV+1)+COL                
            x1 = expc2(-de/(cmf*T))
            x2 = de/(cmf*T)
            IF(DE/(CMF*T) .LT. 50.D0)  
     >           POPC(NV+1,NV)=POPC(NV+1,NV) 
     >           -COL*expc2(-DE/(CMF*T))         
 70      CONTINUE                                                         
C                                                                       
         DO 90, NV=0,NLHT-2 
            DE=EX(NV+2)-EX(NV+1)                            
C                COL=(CH*HDEN+CH2*H2DEN*expc2(-6.01D0*DE/(T+1190.D0)))        
C     >               *((NV+1)    ) 
            COL=COL2*(NV+1)
            x1 = expc2(-de/(cmf*T))
            x2 = de/(cmf*T)
            IF(DE/(CMF*T) .LT. 50.D0)                             
     >           POPC(NV+1,NV+1)=POPC(NV+1,NV+1)                         
     >           +COL*expc2(-DE/(CMF*T))       
            POPC(NV+1,NV+2)=POPC(NV+1,NV+2)-COL                
 80         CONTINUE                                                      
 90      CONTINUE                                                         
      END IF                                                           
C
      RETURN                                                           
      END                                                              
C
C
      SUBROUTINE LQDVIB
       
      Parameter(NLHT=15)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      COMMON /MATRIX/ POPA(NLHT,NLHT),POPP(NLHT),POPC(NLHT,NLHT)
C       COMMON /MATRIX/ POPA(15,15),POPP(15),POPC(15,15)
C
      DO 20, I=1,NLHT
         DO 10, J=1,NLHT
            POPA(I,J)=0.D0
 10      CONTINUE
 20   CONTINUE
C
C
      DO 50, M=1,200                                                  
         READ(1,30,END=51) I,J,A     
 30      FORMAT(2X,I2,2X,I2,2X,1PE10.3) 
         IF(I .NE. J.and.I.LE.NLHT.and.J.LE.NLHT) POPA(I,J)=A  
 50   CONTINUE                                                        
 51   CONTINUE   
      DO 55, I=2,NLHT
         DO 54, J=1,I-1
            POPA(I,I)=POPA(I,I)-POPA(J,I)
 54      CONTINUE
 55   CONTINUE
      RETURN                                                       
C
      END                           
C
C
CMR... PMAT never invoked ...........................
CMR..................................................

      Subroutine PMAT(NX,NY,XMAT)
C	
C	Print Matrix XMAT(NX,NY)
C
      Double Precision XMAT(NX,NY)

      write(*,120)
      Do 10 i=1,NX
         Write(*,110) (XMAT(i,j), j=1,NY) 
 10   continue
 110  format(16(e8.2),/)
 120  format(/,/)        
      return
      end  
C
C                            
      Subroutine Errors(I1)

      Integer I1

      If(I1.eq.1) then
         Write(*,*) 'Error: NLHT must be smaller than 16 !!!'
         stop
      ELSEIF(I1.eq.2) then
         Write(*,*) 'Warning: Maximun number of steps ?? is to small'
         stop
      endif
      return 
      end 
C
C        
      Subroutine Xin(CD,CDD,NR)
        
        
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
 
      DIMENSION CD(NR),CDD(NR) 

      Do 10 i=1,NR
         CD(i) = 0.0d0
         CDD(i) = 0.0d0
 10   continue
      return
      end
      
      FUNCTION expc2(X)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      IF(X .EQ. 0.D0) THEN
         expc2=1.D0
         RETURN
      END IF
      IF(X .GT. -100.D0) THEN
         expc2=DEXP(X)
         RETURN
      END IF
      expc2=0.D0
      RETURN
      END
 
C
C
CBB *************************************************************
      Subroutine Input(XNTOT,SIGD,ZTOT,SINTL,SINTR,COSRAY,BETA,T,
     + 	STEP1,STEP2,HTRY,THRES) 
          
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      Common/Xfrac/ HEFRAC,OfRAC,CFRAC,SIFRAC,C13FRAC

CBB************************************************************ 
      READ(*,110) xntot,sigd,ztot,sintl,sintr,cosray,beta,t,
     + step1,step2,htry,thres
      READ(*,120) HEFRAC,OFRAC,CFRAC,sifrac,c13frac
      write(*,150)
      write(*,130) xntot,sigd,ztot,sintl,sintr,cosray,beta,t
      write(*,140) hefrac,ofrac,cfrac,sifrac,c13frac,thres
CB30.01.97C       stop
 110  format(/,/,/,/,/,e17.10,/,/,e17.10,/,/,e17.10,/,/,e17.10,
     >         /,/,/,e17.10,/,/,e17.10,/,/,e17.10,/,/,e17.10,/,/,
     + e17.10,/,/,e17.10,/,/,e17.10,/,/,e17.10) 
 120  format(/,e17.10,e17.10,e17.10,e17.10,e17.10) 
 150  format('        Xntot         Sigd         Ztot     Sintl',  
     >         '        Sintr         Cosray       Beta          T')
 130  format(1x,8(1x,e12.5))
 140  format(/,'Hefrac: ',e12.5,/,'Ofrac: ',e12.5,/,'Cfrac: ',e12.5,
     >         /,'SIFRAC: ',e12.5,/,'C13FRAC: ',e12.5,/,'threshold:
     + ',e12.5) 
CB	write(*,*) step1,step2
CB	write(*,*)'htry = ',htry
      return
      end
	
CCB       stop
CB110     format(/,/,/,/,/,e17.10,/,/,e17.10,/,/,e17.10,/,/,e17.10,
CB     >         /,/,/,e17.10,/,/,e17.10,/,/,e17.10,/,/,e17.10,/,/,
CB     + e17.10,/,/,e17.10,/,/,e17.10,/,/,e17.10) 
CB120     format(/,e17.10,e17.10,e17.10,e17.10,e17.10) 
CB150     format('        Xntot         Sigd         Ztot     Sintl',  
CB     >         '        Sintr         Cosray       Beta          T')
CB130     format(1x,8(1x,e12.5))
CB140     format(/,'Hefrac: ',e12.5,/,'Ofrac: ',e12.5,/,'Cfrac: ',e12.5,
CB     >         /,'SIFRAC: ',e12.5,/,'C13FRAC: ',e12.5,/,'threshold:
CB     + ',e12.5) 

CB        return
CB        end
C
C

C
C
      SUBROUTINE OUTPUT(ZG,CD,CDD,ITER,T,XNTOT,AV1)
C
C

      Parameter(NLHT=15)
      Parameter(NMAX1=800)
      PARAMETER(NPAR=416)
      PARAMETER(NSP=45)
      PARAMETER(nco=50)
      Parameter(NTRANS=476)
      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
       
      Common/Xtest/ TD1,RFORM1,DCOL12CO,DCOL13CO
      Common/XTA1/ XTLTE(NCO-1),XTLTE13(NCO-1),XTLTE18(NCO-1)
      Common/Xprint/ Ebalpr 
      
      DIMENSION CD(NLHT+NPAR),CDD(NLHT+NPAR),XSPA(NSP),XSPB(NSP)
      DIMENSION ebalpr(18)

      CHARACTER*10 SS(0:NSP)
      DATA SS/'/','HE','HE+','H+','H2+','H3+','C','CH','CO','C+',
     >           'CH+','CH2+','CO+','HCO+','*C','*CH','*CO','*C+',
     >           '*CH+','*CH2+','*CO+','*HCO+','O','OH','H2O','O2',
     >           'O+','OH+','H2O+','H3O+','ELEC','^CO','^CO+',
     >           '^HCO+','^O','^OH','^H2O','^O2','^O+','^OH+',
     >           '^H2O+','^H3O+','O^O','*C^O','*C^O+','H*C^O+'   /
	
cm       DATA SS/'/','HE','C','O','H+','H2+','H3+','HE+','CH','CH2','CH3',
cm     >          'CH4','C+','CH+','CH2+','CH3+','CH4+','CH5+',
cm     >          'OH','H2O','O+','OH+','H2O+','H3O+','CO','CO+',
cm     >          'HCO+','ELEC','O2','O2+','O2H+',
cm     >          '*C','*CH','*CH2','*CH3','*CH4','*C+','*CH+','*CH2+',
cm     >          '*CH3+','*CH4+','*CH5+','*CO','*CO+','*HCO+',
cm     >          'Si','Si+','SiO','SiO+','SiH','SiH2+','HOSi+'/


cm 	  WRITE(11,471)
 471  FORMAT(10X,'---------------------------------------------')    
      ii = int(iter)
cm	  WRITE(11,470) ii
 470  FORMAT(4x,'ITERATION =',1PE10.3,/)
cm          WRITE(11,530) ZG,CD(1),CD(2) 
 530  FORMAT(4X,'ZG =',1PE10.3,
     1              ' H2 COLUMN DENSITY =',1PE10.3,
     1              '  H COLUMN DENSITY =',1PE10.3,/)
cm          WRITE(11,550) CDD(1),CDD(2)
 550  FORMAT(4X,' H2 DENSITY =',1PE10.3,'     H DENSITY =',1PE10.3,
     >           /)
cm          write(11,110) T,TD1,RFORM1
cm          WRITE(11,568)
 568  FORMAT(20X,'H2 DENSITIES')
cm          WRITE(11,570) (CDD(I), I=3,17)
cm          WRITE(11,578)

 578  FORMAT(20X,'H2 COLUMN DENSITIES')
cm          WRITE(11,570) (CD(I), I=3,17)
 570  FORMAT(5(2X,1PE10.3))
 110  Format('TGAS: ',e12.5,2x,'TDUST: ',e12.5,2x,'RFORM: ',e12.5)

c.... 51 --> 45 = NSP
c....          Do 100 i = 1,51
CMR...  sorting of species has changed.

CMR...          Do 100 i = 1,45
CMR...            xspa(i) = CDD(I+17)
CMR...            xspb(i) = CD(I+17)
      xspb(1) = CD(1+17)
      xspb(2) = CD(7+17)
      xspb(3) = CD(4+17)
      xspb(4) = CD(5+17)
      xspb(5) = CD(6+17)
      xspb(6) = CD(2+17)
      xspb(7) = CD(8+17)
      xspb(8) = CD(24+17)
      xspb(9) = CD(12+17)
      xspb(10) = CD(13+17)
      xspb(11) = CD(14+17)
      xspb(12) = CD(25+17)
      xspb(13) = CD(26+17)
      xspb(14) = CD(31+17)
      xspb(15) = CD(32+17)
      xspb(16) = CD(42+17)
      xspb(17) = CD(36+17)
      xspb(18) = CD(37+17)
      xspb(19) = CD(38+17)
      xspb(20) = CD(43+17)
      xspb(21) = CD(44+17)
      xspb(22) = CD(3+17)
      xspb(23) = CD(18+17)
      xspb(24) = CD(19+17)
      xspb(25) = CD(28+17)
      xspb(26) = CD(20+17)
      xspb(27) = CD(21+17)
      xspb(28) = CD(22+17)
      xspb(29) = CD(23+17)
      xspb(30) = CD(27+17)
      xspb(31) = CD(310+17)
      xspb(32) = CD(311+17)
      xspb(33) = CD(312+17)
      xspb(34) = CD(313+17)
      xspb(35) = CD(314+17)
      xspb(36) = CD(315+17)
      xspb(37) = CD(316+17)
      xspb(38) = CD(317+17)
      xspb(39) = CD(318+17)
      xspb(40) = CD(319+17)
      xspb(41) = CD(320+17)
      xspb(42) = CD(321+17)
      xspb(43) = CD(322+17)
      xspb(44) = CD(323+17)
      xspb(45) = CD(324+17)
      
      xspa(1) = CDD(1+17)
      xspa(2) = CDD(7+17)
      xspa(3) = CDD(4+17)
      xspa(4) = CDD(5+17)
      xspa(5) = CDD(6+17)
      xspa(6) = CDD(2+17)
      xspa(7) = CDD(8+17)
      xspa(8) = CDD(24+17)
      xspa(9) = CDD(12+17)
      xspa(10) = CDD(13+17)
      xspa(11) = CDD(14+17)
      xspa(12) = CDD(25+17)
      xspa(13) = CDD(26+17)
      xspa(14) = CDD(31+17)
      xspa(15) = CDD(32+17)
      xspa(16) = CDD(42+17)
      xspa(17) = CDD(36+17)
      xspa(18) = CDD(37+17)
      xspa(19) = CDD(38+17)
      xspa(20) = CDD(43+17)
      xspa(21) = CDD(44+17)
      xspa(22) = CDD(3+17)
      xspa(23) = CDD(18+17)
      xspa(24) = CDD(19+17)
      xspa(25) = CDD(28+17)
      xspa(26) = CDD(20+17)
      xspa(27) = CDD(21+17)
      xspa(28) = CDD(22+17)
      xspa(29) = CDD(23+17)
      xspa(30) = CDD(27+17)
      xspa(31) = CDD(310+17)
      xspa(32) = CDD(311+17)
      xspa(33) = CDD(312+17)
      xspa(34) = CDD(313+17)
      xspa(35) = CDD(314+17)
      xspa(36) = CDD(315+17)
      xspa(37) = CDD(316+17)
      xspa(38) = CDD(317+17)
      xspa(39) = CDD(318+17)
      xspa(40) = CDD(319+17)
      xspa(41) = CDD(320+17)
      xspa(42) = CDD(321+17)
      xspa(43) = CDD(322+17)
      xspa(44) = CDD(323+17)
      xspa(45) = CDD(324+17)

CMR...100       continue

cm          WRITE(11,620)
 620  FORMAT(//,10X,'LOCAL CHEMICAL DENSITIES')
cm          WRITE(11,625) (SS(I),xspa(I), I=1,NSP)
cm          WRITE(11,622)
 622  FORMAT(//,10X,'CHEMICAL COLUMN DENSITIES')
cm          WRITE(11,625) (SS(I),xspb(I), I=1,NSP)
 625  FORMAT(4(A5,1X,1PE10.3,2X))

cm          WRITE(11,668)
 668  FORMAT(20X,'CO DENSITIES')
cm          WRITE(11,570) (CDD(I), I=69,118)
cm          WRITE(11,666)

CB 02.09.1992       Dichte_Plot fuer 12CO
cm          write(38,571) av1,(cdd(i), i=69,73)
 571  format(6(1X,1PE10.3))

 666  FORMAT(20X,'CO DENSITIES LTE-TEST')
cm          WRITE(11,570) (XTLTE(I), I=1,NCO-1)
cm          WRITE(11,678)
 678  FORMAT(20X,'CO COLUMN DENSITIES')
cm          WRITE(11,570) (CD(I), I=69,118)

cm          WRITE(11,868)
 868  FORMAT(20X,'13CO DENSITIES')
cm          WRITE(11,570) (CDD(I), I=127,176)
cm          WRITE(11,866)

CB 02.09.1992    Dichte-Plot fuer 13CO
cm	  write(39,571) av1,(cdd(i), i=127,131)

 866  FORMAT(20X,'13CO DENSITIES LTE-TEST')
cm          WRITE(11,570) (XTLTE13(I), I=1,NCO-1)
cm          WRITE(11,878)
 878  FORMAT(20X,'13CO COLUMN DENSITIES')
cm          WRITE(11,570) (CD(I), I=127,176)

CB ***********************************************************************
cm          WRITE(11,768)
 768  FORMAT(20X,'HEATING-RATES:')
cm          WRITE(11,778)
 778  FORMAT(10X,'H2vib:         H2phot:         H2-formation:')
cm	  WRITE(11,888) EBALPR(1), EBALPR(2),EBALPR(3)
cm	  WRITE(11,779)
 779  FORMAT(10X,'cosmic-ray:    photoelectric:  ')
cm	  WRITE(11,888) EBALPR(7), EBALPR(8)
cm	  WRITE(11,798)
 798  FORMAT(20X,'COOLING-RATES:')	  
cm	  WRITE(11,808)
 808  FORMAT(8X, 'O: 3P2->3P1      O: 3P2->3P0      0:3P1->3P0')
cm	  WRITE(11,888) EBALPR(4),EBALPR(5),EBALPR(6)
cm	  WRITE(11,818)
 818  FORMAT(9X,'12CO            C+             13CO')	  
cm	  WRITE(11,888) EBALPR(9),EBALPR(10),EBALPR(15)
cm	  WRITE(11,783)
 783  FORMAT(8X,'CI: 3P0->3P1    CI: 3P0->3P2     CI: 3P1->3P2')
cm	  WRITE(11,888) EBALPR(11),EBALPR(12),EBALPR(13)
 888  FORMAT(3(7X,1PE10.3))
cm	WRITE(11,828) 
 828  FORMAT(9X,'  OH:          H2O:               GAS-GRAIN:')
cm	  WRITE(11,888) EBALPR(16),EBALPR(17),EBALPR(18)

CB ********************************************************************

CB output min.out	  WRITE(26,471)
CB 06.08.1996	  WRITE(26,477) II,ZG
CB477	  FORMAT(4X,'ITERATION: ',1PE10.3,4X,'ZG:  ',1PE10.3)
CB	  WRITE(26,479) T,CD(1)
CB479 	  FORMAT(4X,'TGAS: ',E12.5,4X,'H2COLUMND.: ',1PE10.3)
CB          WRITE(26,768)
CB          WRITE(26,778)
CB	  WRITE(26,888) EBALPR(1), EBALPR(2),EBALPR(3)
CB	  WRITE(26,779)
CB	  WRITE(26,888) EBALPR(7), EBALPR(8)
CB	  WRITE(26,798)
CB	  WRITE(26,808)
CB	  WRITE(26,888) EBALPR(4),EBALPR(5),EBALPR(6)
CB	  WRITE(26,818)
CB	  WRITE(26,888) EBALPR(9),EBALPR(10),EBALPR(15)
CB	  WRITE(26,783)
CB	  WRITE(26,888) EBALPR(11),EBALPR(12),EBALPR(13)
CB	  WRITE(26,828)
CB	  WRITE(26,888) EBALPR(16),EBALPR(17),EBALPR(18)

CB************************************************************************
CB zg in parsec 
      zz = zg/3.08d18
CB      av1= zg*sigd*xntot/4.0d0

CB Belegung der Daten fuer den Plot T/zg, Datei = plot_T.dat
cm	write(27,498)av1,t,td1

CB Belegung der Daten fuer den Plot Dichten von C/12CO/C+ , Datei = plot_CC.dat
cm	write(28,598) av1,xspa(24),fac13co,xspa(2),xspa(12)
  

CB Belegung der Daten fuer Saeulendichtenverhaeltnis von 12CO/13CO, 12C/13C
CB und 12C+/13C+, Datei = plot_columnratio.dat
CMR...	if (xspb(42).gt.0.0d0) then
CMR...	if (xspb(31).gt.0.0d0) then
CMR...	if (xspb(36).gt.0.0d0) then
CMR...	ratco = xspb(24)/xspb(42)
CMR...	ratc = xspb(2)/xspb(31)
CMR...	ratcc = xspb(12)/xspb(36)
      if (xspb(16).gt.0.0d0) then
         if (xspb(14).gt.0.0d0) then
            if (xspb(17).gt.0.0d0) then
               ratco = xspb(8)/xspb(16)
               ratc = xspb(6)/xspb(14)
               ratcc = xspb(9)/xspb(17)
cm	write(34,498) av1,ratco,ratc,ratcc
 498           format(4(1pe10.3))
            endif
         endif
      endif

 499  format (4(1pe10.3))
CB Belegung der Daten fuer den Plot n(12CO,13CO,C,C+,O,13C,13C+)
CB   Datei = plot_rat.dat 
CMR...	fac13co = 66*xspa(42)
CMR...	fac13cI = 66*xspa(31)
CMR...	fac13CII = 66*xspa(36)

      fac13co = 66*xspa(16)
      fac13cI = 66*xspa(14)
      fac13CII = 66*xspa(17)
cm	write(29,598) av1,xspa(24),fac13co,xspa(2),xspa(12),xspa(3),
cm     >   fac13cI, fac13cII  

CB Belegung der Daten fuer den plot Saeulendichten(12CO)
CB gegen self-shielding Faktoren (dcol). selfsf12.dat
CB10.11.93	write(14,499) xspb(24),DCOL12CO 


CB Belegung der Daten fuer den plot Saeulendichten(13CO)
CB gegen self-shielding Faktoren (dcol). selfsf12.dat
cm	write(16,499) xspb(42),DCOL13CO 

 598  format(8(1pe10.3))
CB ****************** Kuehlraten_Plots: ***************************
      ebal4 = ebalpr(4)
      ebal6 = ebalpr(6)
      ebal10 = ebalpr(10)
      ebal15 = ebalpr(15)
      ebal9 = ebalpr(9)
      ebal18 = ebalpr(18)
      ebal16 = ebalpr(16)
CB	write(*,*) '1. ebal4=', ebal4
      if (ebal4.eq. 0) then
         ebal4 = 1.0d-35  
CB		write(*,*) '2. ebal4=', ebal4
      end if       
      if (ebal6 .eq. 0) then
         ebal6 = 1.0d-35  
      end if
      if (ebal10 .eq. 0) then
         ebal10 = 1.0d-35  
      end if
      if (ebal15 .eq. 0) then 
         ebal15 = 1.0d-35  
      end if
      if (ebal9 .eq. 0) then
         ebal9 = 1.0d-35  
      end if
      if (ebal18 .eq. 0) then
         ebal18 = 1.0d-35  
      end if
      if (ebal16 .eq. 0) then
         ebal16 = 1.0d-35  
      end if

CB	write(*,*) 'ebal4 =',ebal4
      ebal4 = dlog10(abs(ebal4))
      ebal6 = dlog10(abs(ebal6))
      ebal10 = dlog10(abs(ebal10))
      ebal15 = dlog10(abs(ebal15))
      ebal9 = dlog10(abs(ebal9))
      ebal18 = dlog10(abs(ebal18))
      ebal16 = dlog10(abs(ebal16))

 501  format (8(1X,1pe10.3))
CB Belegung der Daten fuer die Kuehlraten , Datei = plot_cool1.dat
CB	if (iter.eq.1) then
cm	write(31,501) av1,ebal4,ebal6,ebal10,ebal9,ebal15,
cm     >               ebal18,ebal16
CB	endif

CB Belegung der Daten fuer die Kuehlraten  Datei = plot_cool2.dat
CB	if (iter.eq.2) then
CB	write(32,501) av1,ebal4,ebal6,ebal10,ebal14
CB     +,ebal9
CB	endif

CB Belegung der Daten fuer die Kuehlraten 3.Iteration, Datei = plot_cool3.dat
CB	if (iter.eq.3) then
CB	write(33,501) zz,ebal4,ebal6,ebal10,ebal14
CB     +,ebal9
CB	endif

CB Belegung der Daten fuer die Kuehlraten 4.Iteration, Datei = plot_cool4.dat
CB	if (iter.eq.4) then
CB	write(34,501) zz,ebal4,ebal6,ebal10,ebal14
CB     +,ebal9
CB	endif

CB ***************** Heizraten-Plots:  ******************************

      ebal1 = ebalpr(1)
      ebal2 = ebalpr(2)
      ebal3 = ebalpr(3)
      ebal7 = ebalpr(7)
      ebal8 = ebalpr(8)

      if (ebal1 .eq. 0) then
         ebal1 = 1.0d-35 
      end if 
      if (ebal2 .eq. 0) then
         ebal2 = 1.0d-35  
      end if
      if (ebal3 .eq. 0) then
         ebal3 = 1.0d-35  
      end if 
      if (ebal8 .eq. 0) then
         ebal8 = 1.0d-35  
      end if
      if (ebal7 .eq. 0) then
         ebal7 = 1.0d-35  
      end if 
      
      ebal1 = dlog10(abs(ebal1))
      ebal2 = dlog10(abs(ebal2))
      ebal3 = dlog10(abs(ebal3))
      ebal8 = dlog10(abs(ebal8))
      ebal7 = dlog10(abs(ebal7))
CB	write(*,*) 'ebalpr(1) = ',ebalpr(1)
CB	write(*,*) 'ebal1 = ',ebal1
CB Belegung der Daten fuer die Heizraten  Datei = plot_heat1.dat
CB	if (iter.eq.1) then
cm	write(36,501) av1,ebal1,ebal2,ebal3,ebal8,ebal7
CB	endif

CB Belegung der Daten fuer die Dissoziationsraten von 12CO und 13CO 
CB in Av, Datei = plot_dcol.dat
cm	write(37,501) av1,DCOL12CO,DCOL13CO

CB Belegung der Daten fuer die Heizraten 3.Iteration, Datei = plot_heat3.dat

CB	if (iter.eq.3) then
CB	write(38,501) zz,ebal1,ebal2,ebal3,ebal8
CB     +,ebal7
CB	endif

CB Belegung der Daten fuer die Heizraten 4.Iteration, Datei = plot_heat4.dat

CB	if (iter.eq.4) then
CB	write(39,501) zz,ebal1,ebal2,ebal3,ebal8
CB     +,ebal7
CB	endif

C         ------------------------------------------------------------------
C                          General Output, 10.01.1995, 05.07.1995, 07.11.95
C         ------------------------------------------------------------------

C         General Output for densities and column densities
C         Output  fuer 'dens*.out'
      write(41,4001) av1,((cdd(i)/xntot),i=1,381)
C         Output  fuer 'dens*zg.out'
CB.02.1995          write(115,4001) zz,((cdd(i)/xntot),i=1,183)
C         Output  fuer 'coldens*.out'
      write(42,4001) av1,((cd(i)),i=1,381)
C         Output  fuer 'coldens*zg.out'
CB15.02.1995          write(116,4001) zz,((cd(i)),i=1,183)
 4001 format(382(E12.5))


C         General Output for heating and cooling rates
C         Output for 'heatcool*.out'
      write(43,4002) av1,(ebalpr(i),i=1,18) 
C         Output for 'heatcool*zg.out'
CB15.02.1995	  write(117,4002) zz,(ebalpr(i),i=1,18) 
 4002 format(19(E12.5))

C         General Output for gas and dust temperature
C         Output for 'temp*.out' 
      write(44,4003) av1,T,TD1
C         Output for 'temp*zg.out'
CB15.02.1995	  write(118,4003) zz,T,TD1
 4003 format(3(E12.5))


C         ------------------------------------------------------------------
C                          End
C         ------------------------------------------------------------------
      RETURN
      END
 

      SUBROUTINE SFAC(T,SINTL,SINTR,TAUDL,TAUDR,TD,RFORM)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C         GRAIN FORMATION RATE COEFFICIENT.
C
      F1=(2.134D-04*SINTL*expc2(-TAUDL))**0.2D0
      F2=(2.134D-04*SINTR*expc2(-TAUDR))**0.2D0
      F =F1+F2 
      TD=35.35D0*F
      TDLOW=10.D0
      TD=MAX(TD,TDLOW)
      RFORM=T**0.5D0/(1.0d0+0.04d0*(T+TD)**0.5d0+
     >     2.0D-03*T+8.0D-06*T**2.D0)
      RFORM=3.0D-18*RFORM/(1.D0+1.0D+04*expc2(-600.D0/TD))
C         RFORM=3.0D-18*T**0.5D0
C         RFORM=RFORM/5.0D0
      RETURN
      END
 
  
 
