
C         Program controls Output of PDR program
C
C         H. Stoerzer 23.6.94
C
 
          IMPLICIT DOUBLE PRECISION (A-H,O-Z)

          Double Precision cdd(381),cd(381),av,xhcrat(20) 
          Integer Indx(10),Indxcool(10),Indxheat(10)

C         Density In/Out 
c          OPEN(101,file='pdrdensav.out',STATUS='OLD')
c          OPEN(102,file='pdrdenszg.out',STATUS='OLD')
c          OPEN(21,file='densityav.dat',STATUS='new')
          OPEN(102,file='dens50402930.out',STATUS='OLD')
          OPEN(22,file='densityzg.dat',STATUS='new')

C         ColumnDensity In/Out
c          OPEN(103,file='pdrcoldensav.out',STATUS='OLD')  
c          OPEN(104,file='pdrcoldenszg.out',STATUS='OLD')  
c          OPEN(23,file='coldensav.dat',STATUS='new')
c          OPEN(24,file='coldenszg.dat',STATUS='new')

C         Heating/Cooling In/Out
c          OPEN(105,file='heatcoolav.out',STATUS='OLD')
c          OPEN(106,file='heatcoolzg.out',STATUS='OLD')
c          OPEN(25,file='heatav.dat',STATUS='new')
c          OPEN(26,file='heatzg.dat',STATUS='new')
c          OPEN(27,file='coolav.dat',STATUS='new')
c          OPEN(28,file='coolzg.dat',STATUS='new')

C         Temperature In/Out
c          OPEN(107,file='tgastdustav.out',STATUS='OLD')
c          OPEN(108,file='tgastdustzg.out',STATUS='OLD')
c          OPEN(29,file='tav.dat',STATUS='new')
c          OPEN(30,file='tzg.dat',STATUS='new')

c          open(99,file='coldens.ratio')
 
C         Pointer for Density and Column Density 
C         Output Control (max 10) (see PDR Manual
C         for relation between index and species)
         
          Indx(1) = 19
          Indx(2) = 29
          indx(3) = 41
          indx(4) = 20                   
          Nindx   = 4


C         Density

C         Density (as function of av)
c          NR=0
c          Do i=1,1000
c            NR = NR+1
c            Read(101,4001,END=150) av,(cdd(k),k=1,381)
c            Write(21,110) av,
c     >                   (dlog10(cdd(indx(k))+1.0D-50),k=1,Nindx)


c   hier hab ich mit den haeufigkeiten multipliziert
c            write(21,110) av,dlog10(cdd(41)),dlog10(cdd(59)*66),
c     >                   dlog10(cdd(327)*500),dlog10(cdd(339)*500*66)


c          Enddo
c          Write(*,*) 'Error: Number of grid points larger than 1000'
c          stop 
c 150       continue

C         Density (as function of zg)
          NR=0
          Do i=1,1000
            NR = NR+1
            Read(102,4001,END=250) zg,(cdd(k),k=1,381)
c           Write(22,110) zg,
c     >                   (dlog10(cdd(indx(k))+1.0D-50),k=1,Nindx)

            write(22,110) zg,dlog10(cdd(41)),dlog10(cdd(59)*66.0d0),
     >                   dlog10(cdd(327)*500),dlog10(cdd(339)*500.0d0
     >                                                *66.0d0)

c       test - ratio
c            write(22,110) zg,(cdd(41))/(cdd(59))




          Enddo
          Write(*,*) 'Error: Number of grid points larger than 1000'
          stop 
250       continue


C         Column Density

C         Column density (as function of av)
c          NR=0
c          Do i=1,1000
c            NR = NR+1
c            Read(103,4001,END=350) av,(cd(k),k=1,381)
c            Write(23,110) av,
c     >                   (dlog10(cd(indx(k))+1.0D-50),k=1,Nindx)


c       test - coldensratio
c            write(99,110) av,(cd(41))/(cd(59))

c          Enddo
c350       continue

C         Column density (as function of zg)
c          NR=0
c          Do i=1,1000
c            NR = NR+1
c            Read(104,4001,END=450) zg,(cd(k),k=1,381)
c            Write(24,110) zg,
c     >                   (dlog10(cd(indx(k))+1.0D-50),k=1,Nindx)
c          Enddo
c450       continue


C         Gas- and Dust-Temperature 
c          NR=0
c          Do i=1,1000
c            NR = NR+1
c            Read(107,4003,END=550) av,Tgas,Tdust 
c            Read(108,4003,END=550) zg,Tgas1,Tdust1 
c            Write(29,120) av,Tgas,Tdust  
c            Write(30,120) zg,Tgas,Tdust   
c            Write(*,120)  av,Tgas,Tdust  
c            Write(*,120)  zg,Tgas,Tdust   
c          Enddo
c550       continue





C         Pointer for Cooling rates 
C         Output Control (max 10) (see PDR Manual
C         for relation between index and coolant)
c          Indxcool(1) = 19 
c          Indxcool(2) = 4
c          Nindx = 2

c          Do i=1,1000
c            NR = NR+1
c            Read(105,4002,END=650) av,(xhcrat(k),k=1,20)
c            Write(27,120) av,
c     >      (dlog10(abs(xhcrat(indxcool(k))+1.0D-50)),k=1,Nindx)
c          Enddo
c650       Continue

c          Do i=1,1000
c            NR = NR+1
c            Read(106,4002,END=750) zg,(xhcrat(k),k=1,20)
c            Write(28,120) zg,
c     >      (dlog10(abs(xhcrat(indxcool(k))+1.0D-50)),k=1,Nindx)
c          Enddo
c750       Continue

c          Rewind 105
c          Rewind 106
 
C         Pointer for Heating rates 
C         Output Control (max 10) (see PDR Manual
C         for relation between index and heating process)
c          Indxheat(1) = 1 
c          Indxheat(2) = 2 
c          Indxheat(3) = 3 
c          Indxheat(4) = 7 
c          Indxheat(5) = 8
c          Nindx = 5

c          Do i=1,1000
c            NR = NR+1
c            Read(105,4002,END=850) av,(xhcrat(k),k=1,20)
c            Write(25,120) av,
c     >      (dlog10(abs(xhcrat(indxheat(k))+1.0D-50)),k=1,Nindx)
c          Enddo
c850       Continue

c          Do i=1,1000
c            NR = NR+1
c            Read(106,4002,END=950) zg,(xhcrat(k),k=1,20)
c            Write(26,120) zg,
c     >      (dlog10(abs(xhcrat(indxheat(k))+1.0D-50)),k=1,Nindx)
c          Enddo
c950       Continue
 
 
110       Format(11(E12.5,' '))
120       Format(11(E12.5))
4001      Format(311(E12.5))
4002      Format(21(E12.5))
4003      Format(3(E12.5))
4004      Format(20(E12.5))
          END 
  
 
